package cn.iocoder.yudao.module.attendance.service.business;

import java.time.LocalDate;
import java.util.*;
import cn.iocoder.yudao.module.attendance.controller.admin.business.vo.*;
import cn.iocoder.yudao.module.attendance.dal.dataobject.business.AttendanceBusinessDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import org.apache.ibatis.annotations.Param;

import javax.validation.Valid;

/**
 * 出差信息 Service 接口
 *
 * @author zhaopq
 */
public interface AttendanceBusinessService {

    /**
     * 创建出差信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createBusiness(@Valid AttendanceBusinessSaveReqVO createReqVO);

    /**
     * 更新出差信息
     *
     * @param updateReqVO 更新信息
     */
    void updateBusiness(@Valid AttendanceBusinessSaveReqVO updateReqVO);

    /**
     * 删除出差信息
     *
     * @param id 编号
     */
    void deleteBusiness(Long id);

    /**
     * 获得出差信息
     *
     * @param id 编号
     * @return 出差信息
     */
    AttendanceBusinessDO getBusiness(Long id);

    /**
     * 获得出差信息分页
     *
     * @param pageReqVO 分页查询
     * @return 出差信息分页
     */
    PageResult<AttendanceBusinessDO> getBusinessPage(AttendanceBusinessPageReqVO pageReqVO);

    AttendanceBusinessDO selectByDateAndEmployeeId(LocalDate date, Long employeeId);


}